import java.util.Vector;

public class NLSubjectIsolator extends NLPhraseEvaluator {
// First call the compile method, to get something into the parts vector.
// Then when you call the isolate method, you will get the evaluators array
// to hold three NLPhraseEvaluators. The middle one will hold those parts
// that belong to the subject; the others will hold the rest, and either of
// them may have an empty parts vector.
  
  //Inherited fields:
  //Vector parts
  
  //New fields:
  NLPhraseEvaluator[] evaluators = new NLPhraseEvaluator[3];

  public NLSubjectIsolator(String phrase) {
    super(phrase);
  }
  
  protected void isolate() {
    for (int i = 0; i < 3; i++) {
      evaluators[i] = new NLPhraseEvaluator();
    }
    Evaluable[] a = new Evaluable[0];
    a = (Evaluable[]) parts.toArray(a);
    if (a!=null) {
      int progress = 0; //Says whether we're before, in, or after the subject.
      Evaluable ev; boolean b;
      for (int i = 0; i < a.length; i++) {
        ev = a[i];
        b = ev.grammaticalRole!=null &&
            ev.grammaticalRole.equals(Evaluable.SUBJECT_ROLE);
        if (b) {progress = 1;}
        else {progress = (progress==0?0:2);}
        evaluators[progress].addPart(ev);
      }
    }
  }

}
