 

public class NLTuple extends NLTerm {

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------

  NLTerm[] tt;
  boolean isInWords = false;
  String translation = "";

// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public NLTuple(NLTerm[] t) {
    tt = t;
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------

  public String xlat(int mode) {
    String s = "(";
    for (int i = 0; i < tt.length; i++) {
      s += (i>0?",":"")+tt[i].xlat(mode);
      this.isInWords |= tt[i].isInWords();
    }
    s += ")";
    this.translation = s;
    return s;
  }
  
  public boolean isInWords() {
  //Should be called *after* xlat.
    return isInWords;
  }
  
  public String getString() {
  //Should be called *after* xlat.
    return translation;
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 
